SpellWatch.IconMenu = { };

-- Open the icon menu to select an icon
function SpellWatch.IconMenu:Open(previcon, save, point, rframe, rpoint)

	self.selection = (type(previcon) == "string") and previcon or "Interface\\Icons\\INV_Misc_QuestionMark";
	self.save = save;

	SpellWatchIconMenuFrameSelectedTexture:SetTexture(self.selection);
	SpellWatchIconMenuFrameSelectedFile:SetText(self.selection);

	self.frame:ClearAllPoints();
	self.frame:SetPoint(point or "CENTER", rframe or "UIParent", rpoint or "CENTER");
	self.frame:Show();

end

-- Builds the list of icons
function SpellWatch.IconMenu:OnLoad(frame)

	local i;

	self.frame = frame;
	self.icons = {}
	self.offset = 0;
	self.selection = nil;
	self.save = nil;

	--LoadAddOn("Blizzard_MacroUI");

	for i = 1, GetNumMacroIcons() do
		table.insert(self.icons, GetMacroIconInfo(i));
	end

end

-- Updates the list of icons shown
function SpellWatch.IconMenu:IconListUpdate()

	local icon;

	FauxScrollFrame_Update(SpellWatchIconMenuFrameScrollBar, math.floor(table.getn(self.icons)/5 + 0.8), 5, 32);

	self.offset = FauxScrollFrame_GetOffset(SpellWatchIconMenuFrameScrollBar);

	for icon = 1, 25 do

		local button = getglobal("SpellWatchIconMenuFrameIcon"..icon);
		local index = 5*self.offset + icon;

		if ( index <= table.getn(self.icons) ) then
			button:SetNormalTexture(self.icons[index]);
			button:SetPushedTexture(self.icons[index]);
			button:Show();
			if self.selection and self.selection == self.icons[index] then
				button:LockHighlight();
			else
				button:UnlockHighlight();
			end
		else
			button:Hide();
		end

	end

end

-- Set the selection given a path to a texture file
function SpellWatch.IconMenu:SetSelection(file)

	if not file then return; end

	self.selection = file;

	SpellWatchIconMenuFrameSelectedTexture:SetTexture(file);
	SpellWatchIconMenuFrameSelectedFile:SetText(file);

	if type(self.save) == "function" then self.save(self.selection); end
	
	self:IconListUpdate();

end

-- Set the texture based on a button click
function SpellWatch.IconMenu:IconOnClick(id)

	if not id then return; end
	
	self:SetSelection(self.icons[5*self.offset + id]);

end
